"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.BatchModuleContract = void 0;
const objects_1 = require("@hypernetlabs/objects");
const ethers_1 = require("ethers");
const neverthrow_1 = require("neverthrow");
class BatchModuleContract {
    constructor(providerOrSigner, contractAddress) {
        this.contract = null;
        this.contract = new ethers_1.ethers.Contract(contractAddress, objects_1.GovernanceAbis.BatchModule.abi, providerOrSigner);
    }
    batchRegister(registryAddress, registryEntries) {
        var _a;
        const recipients = registryEntries.map((registryEntry) => registryEntry.owner);
        const labels = registryEntries.map((registryEntry) => registryEntry.label);
        const datas = registryEntries.map((registryEntry) => registryEntry.tokenURI);
        const tokenIds = registryEntries.map((registryEntry) => registryEntry.tokenId);
        return neverthrow_1.ResultAsync.fromPromise((_a = this.contract) === null || _a === void 0 ? void 0 : _a.batchRegister(recipients, labels, datas, tokenIds, registryAddress), (e) => {
            return new objects_1.BatchModuleContractError("Unable to call BatchModuleContract batchRegister()", e);
        })
            .andThen((tx) => {
            return neverthrow_1.ResultAsync.fromPromise(tx.wait(), (e) => {
                return new objects_1.BatchModuleContractError("Unable to wait for tx", e);
            });
        })
            .map(() => { });
    }
}
exports.BatchModuleContract = BatchModuleContract;
//# sourceMappingURL=BatchModuleContract.js.map