import { EthereumAccountAddress, EthereumContractAddress, RegistryFactoryContractError } from "@hypernetlabs/objects";
import { BigNumber, ethers } from "ethers";
import { ResultAsync } from "neverthrow";
import { IRegistryFactoryContract } from "./IRegistryFactoryContract";
export declare class RegistryFactoryContract implements IRegistryFactoryContract {
    protected providerOrSigner: ethers.providers.Provider | ethers.providers.JsonRpcSigner | ethers.Wallet;
    protected contract: ethers.Contract | null;
    constructor(providerOrSigner: ethers.providers.Provider | ethers.providers.JsonRpcSigner | ethers.Wallet, contractAddress: EthereumContractAddress);
    getContractAddress(): EthereumContractAddress;
    getContract(): ethers.Contract | null;
    addressToName(registryAddress: EthereumContractAddress): ResultAsync<EthereumContractAddress, RegistryFactoryContractError>;
    enumerableRegistries(index: number): ResultAsync<EthereumContractAddress, RegistryFactoryContractError>;
    nameToAddress(registryName: string): ResultAsync<EthereumContractAddress, RegistryFactoryContractError>;
    getNumberOfEnumerableRegistries(): ResultAsync<number, RegistryFactoryContractError>;
    registrationFee(): ResultAsync<BigNumber, RegistryFactoryContractError>;
    createRegistryByToken(name: string, symbol: string, registrarAddress: EthereumAccountAddress, enumerable: boolean): ResultAsync<void, RegistryFactoryContractError>;
    modules(index: number): ResultAsync<EthereumContractAddress, RegistryFactoryContractError>;
    getModuleName(moduleAddress: EthereumContractAddress): ResultAsync<string, RegistryFactoryContractError>;
    getNumberOfModules(): ResultAsync<number, RegistryFactoryContractError>;
}
//# sourceMappingURL=RegistryFactoryContract.d.ts.map